# $Id: $
# -*- encoding: utf-8 -*-
 
import poplib
import string
import UserDict,UserString
import base64,quopri
import os,sys
import decoder
from MailBox import MBox
import email # for email.message_from_string()

# Errors 
GiveMeEncodedString = ""

DEBUG = 1

def usage():
    print
    print "  usage> python %s server id pass" % (sys.argv[0])
    print

def debug(str):
    global DEBUG
    if DEBUG:
        print "(DEBUG) %s " % str
 
def debug_pretty(str):
    global DEBUG
    if DEBUG:
        import pprint
        pp = pprint.PrettyPrinter(indent=4)

class FilterString(UserString.UserString):
    is_encoded = False
    def __init__(self,s):
        self.data = s
 
class FiltersCore(UserDict.UserDict):
    def addFilter(self,t,s):
        if not isinstance(s,list):
            s = [s]

        # decode all
        s = [w.decode('utf-8') for w in s]

        if t in self.keys():
            self[t].extend(s)
        else:
            self[t] = s
 
    def addSubjectFilter(self,s):
        self.addFilter("Subject",s)
 
    def addFromFilter(self,s):
        self.addFilter("From",s)
 
    def toString(self):
        ret = ''
        for (k,v) in self.items():
            ret = ret + k + " : " + ','.join(v) + "\n"
        return ret
 
class FiltersDict(FiltersCore):
    pass
 
class AegisCore:
    msg = []
    checked = None
 
    def setFilters(self,filters):
        self.filters = filters
 
    def checkMails(self):
        pass
 
    def connect(self,host,user,pass_):
        self.host = host
        self.user = user
        self.pass_ = pass_
 
class AegisCorePOP3(AegisCore):
    M = None
    spamMsgs = {}
    ddt_mbox = None
 
    def connect(self,host,user,pass_):
        AegisCore.connect(self,host,user,pass_)
 
        self.M = poplib.POP3(self.host)
        self.M.user(self.user)
        self.M.pass_(self.pass_)
 
        if not self.M:
            #raise AegisInvalidArguments
            return False

    '''
    def filter_headers(self,header):
        for line in header:
            line_ = line.split(":")
            
            if len(line_) > 1:
                header_name,header_cont = line_[0],' '.join(line_[1:])
            else:
                header_cont = ' '.join(line_)
            
            if header_name in self.filters.keys():
                decoded_header_cont = decoder.decodestring(header_cont)
                print header_name,header_cont,"->",
                for wd in self.filters[header_name]:
                    print wd,
                    if wd in decoded_header_cont:
                        print True
                        return header_name, header_cont, wd
                    else:
                        print False,
                print

        return False
    '''

    def filter_headers(self,header):
        for line in header:
            line_ = line.split(":")
            
            if len(line_) > 1:
                header_name,header = line_[0],' '.join(line_[1:])
            else:
                header = ' '.join(line_)
            
            if header_name in self.filters.keys():
                decoded_header = decoder.decodestring(header)
                for wd in self.filters[header_name]:
                    try:
                        # 인코딩 없이 euc-kr 로 직접 날아오는 메일은 디코드
                        decoded_header = decoded_header.decode('euc-kr')
                    except:
                        pass
                    
                    try:
                        if wd in decoded_header:
                            print "%s: %s" % (header_name,decoder.decodestring(header).encode('utf-8'))
                            return header_name,header,wd
                    except UnicodeDecodeError:
                        pass
                            
##                     if wd.encode('utf-8') in 
##                     try:
##                         if repr(wd) in repr(decoded_header):
##                             return header_name, header, wd
##                     except UnicodeDecodeError,e:
##                         if wd in header:
##                             return header_name,header,wd
                        
                        #passdecoded_header.decode('euc-kr')
                        #print "UnicodeDecodeError",e
                    

        return False

    def filter_headers2(self,header):
        "스팸단어가 들어있다면 해당 line을, 아니면 False 를 리턴"
        for line in header:
            # 0: From, Subject 등등 / 1: 내용
            line_ = line.split(":")
 
            # 이 줄에 헤더 이름이 없으면 윗 줄에 연결된 것이다
            if len(line_) > 1:
                header_name,header_cont = line_[0],' '.join(line_[1:])
            else:
                header_cont = ' '.join(line_)

            decoded_header_cont = decoder.decodestring(header_cont)
            
            if header_name in self.filters.keys():
                for wd in self.filters[header_name]:
                    count1 += 1
                    # whether string is encoded by base64/quopri or not
                    try:
                        if wd in decoded_header_cont:
                            ret = line,wd
                            break
                    except UnicodeDecodeError:
                        count2 += 1
                    #except UnicodeDecodeError,e:
                    #print decoded_header_cont
                    #return True

        print (count1,count2)
        if ret:
            return ret
        # not spam
        return False
                 
    def checkMails(self):
        # TODO: 나중에 octets 를 계산해서 1/2 나 2/3 에서 스팸필터링을 합시다
        try:
            mesg_nums = []
            #print self.M.list()[1]
            for data in self.M.list()[1]:
                # data : 'mesg_num octets'
                mesg_nums.append(data.split()[0])
 
            # 헤더정보를 가져와서 사전에 저축
            # self.filters 내용을 참조해서 필요한 것만 저장한다
            for which in mesg_nums:
                # self.M.top(which,0) = message_header plus 0 line, octet
                header = self.M.top(which,0)
                _t = self.filter_headers(header[1][:-1])
                if _t: # It's a spam!
                    self.spamMsgs[int(which)] = _t
            self.checked = True # sentinel
 
        except poplib.error_proto, e:
            print "poplib.error_proto: " % e
 
        return True
 
    def printSpamMsgs(self):
        if self.checked:
            print self.spamMsgs
 
    def deleteMsg(self):
        self.ddt_mbox = MBox("spamMail","a")
        if self.checked:
            spams = self.spamMsgs.keys()
            
            for spamnum in spams:
                m = "\r\n".join(self.M.retr(spamnum)[1])
                f = email.message_from_string(m)
                self.ddt_mbox.append(f)
                
            for spamnum in spams:
                self.M.dele(spamnum)
                 
    def disconnect(self):
        try:
            self.M.quit()
        except:
            pass
    
    def finalize(self):
        self.disconnect()
        try:
            self.ddt_mbox.close()
        except:
            pass
         
if __name__ == "__main__":
    filters = FiltersDict()
 
    subject = ["샘플","무료","중개사","광고","토익","TOEIC","FREE","stock",
               "신용","자동차","코리아타운","gasoline","복권","CHOL","fuel",
               "cash","PAY","pay","CASINO","MEDICATION","medication","속보",
               "연체","상환","Gas","opinion","자기야","보험","창업","유망직종"]
    filters.addSubjectFilter(subject)
 
    from_ = ["CHOL","e4u","TOEIC","newsletter","올앳","YBM","ybmsisa","allat"]
    filters.addFromFilter(from_)
    #print filters.toString()
 
    if len(sys.argv)>3:
        print repr(sys.argv[1:4])
        host,id,pass_ = sys.argv[1:4]
    else:
        usage()
        sys.exit()
 
    try:
        aegis = AegisCorePOP3()
        aegis.setFilters(filters)
        aegis.connect(host,id,pass_)
        aegis.checkMails()
        aegis.deleteMsg()
    finally:
        aegis.finalize()

# Local Variables:
# mode: python
# End:
        
